C
C  Program : CUTCIFP2
C            First step in the preparation of the CIFs from GRINSP
C                                         for the PCOD
C            Predicted Crystallography Open Database : 
C                        http://www.crystallography.net/pcod/
C
C   Armel Le Bail (alb@cristal.org) - March 2003
C           updated November 2005, February 2006
C
C
C
C
      program main
      character*40 fname,fname1,infile,tchem
      character*80 text,textl
      character*16 textd
      character*2 at1,at2,at3,aa1,aa2,aa3,idt
      logical lexist
      integer na1,na2,na3,nb1,nb2,nb3,nt1,nt2,nt3,ntchem
      write
     1(*,'('' Enter name of multiple CIF (no extension) :'',$)')
      read (*,'(a)')fname1
      if (fname1 .eq. '0') goto 1
      if (fname1 .eq. ' ') goto 1
      write(*,'('' Enter number of first output cif files) :'',$)')
      read (*,'(i)')ncif
C ---- now open file
      ilen=leng(fname1)
      infile=fname1(1:ilen)//'.cif'
      open (25,file=infile,status='unknown')
C
      jj=ncif-1
C
C Loop on the new output CIF files
C
      read(25,'(a)')text
      if(text.eq.' ')go to 20
1     if(text(1:5).eq.'data_')then
100   read(25,'(a)')text
      if(text.eq.' ')go to 100
        close (26)
        jj=jj+1
        write(fname1,'(i7)')jj
        fname=fname1(1:7)//'.cif'
        open (26,file=fname,status='new')
      textd(1:9)='data_PCOD'
      textd(1:16)=textd(1:9)//fname1 
      write(26,'(a)')textd(1:16)
      jpcod=0
        na1=2
        na2=2
        na3=2
      endif
C
C
C
      ilen=leng(text)
C
C
C   Detect "PCOD" in the line and add the new file number...
C
          ilen=leng(text)
          do k=1,ilen-3
            if(text(k:k+3).eq.'PCOD')then 
            text(k:k+10)=textd(6:16)
            jpcod=jpcod+1
            endif
          enddo
C
C Write the line...
C
      ilen=leng(text)
      write(26,'(a)')text(1:ilen)
      textl=text
20    continue
      read(25,'(a)',err=40)text
      if(text.eq.' ')go to 20
      go to 1
C
C End of loop
C
40    close (26)
      close (25)
C
      stop
      end
C
C----------------------------------------------------------------------
C
      integer function leng(string)
C     returns significant length of  'string'
      character*(*)string
      do 1 leng=len(string),0,-1
1        if (string(leng:leng) .ne. ' ') goto 2
2     end
C
C----------------------------------------------------------------------C
C



      INTEGER FUNCTION IGCD (M,N)
C
C-----------------------------------------------------------------------
C   IGCD   WRITTEN BY CHARLES P. REEVE, STATISTICAL ENGINEERING
C          DIVISION, NATIONAL BUREAU OF STANDARDS, GAITHERSBURG,
C          MARYLAND  20899
C
C   FOR: COMPUTING THE GREATEST COMMON DIVISOR OF THE INTEGERS M AND N.
C        IF M=N=0 THEN THE G.C.D. IS DEFINED TO BE ZERO.
C
C   SUBPROGRAMS CALLED: -NONE-
C
C   CURRENT VERSION COMPLETED FEBRUARY 3, 1987
C-----------------------------------------------------------------------
C
      I = IABS(N)
      IGCD = IABS(M)
      IF (IGCD.NE.0) GO TO 10 
      IGCD = I
      RETURN
   10 K = MOD(I,IGCD)
      IF (K.EQ.0) RETURN
      I = IGCD
      IGCD = K
      GO TO 10
      END 
      INTEGER FUNCTION IGCDV (M,N)
C
C-----------------------------------------------------------------------
C   IGCDV   WRITTEN BY CHARLES P. REEVE, STATISTICAL ENGINEERING
C           DIVISION, NATIONAL BUREAU OF STANDARDS, GAITHERSBURG,
C           MARYLAND  20899
C
C   FOR: COMPUTING THE GREATEST COMMON DIVISOR OF THE N INTEGERS IN THE
C        VECTOR M.  IF M(1)=M(2)=...=M(N)=0 THEN THE G.C.D. IS DEFINED
C        TO BE ZERO.
C
C   SUBPROGRAMS CALLED: IGCD
C
C   CURRENT VERSION COMPLETED FEBRUARY 3, 1987
C-----------------------------------------------------------------------
C
      DIMENSION M(*)
      IGCDV = M(1)
      DO 10 I = 1, N
         L = IABS(M(I))
         IGCDV = IGCD(IGCDV,L)
         IF (IGCDV.EQ.1) RETURN
   10 CONTINUE
      RETURN
      END 

